#!/usr/bin/perl -w

# given three corpora in acopost cooked format, this does tagging
# by choosing the majority tag or, else, the tag of the first 
# tagger

# usage:
# simple_majority_tagger.pl first_corpus second_corpus third_corpus 
#    > majority_tagged_corpus

$first = shift;
$second = shift;
$third = shift;

open C1,"$first" or die "could not open $first";
open C2,"$second" or die "could not open $second";
open C3,"$third" or die "could not open $third";

while (<C1>) {
    $l1 = $_;
    $l2 = <C2>;
    $l3 = <C3>;

    @l1 = split '\s+',$l1;
    @l2 = split '\s+',$l2;
    @l3 = split '\s+',$l3;

    $k = 1;
    foreach $e1 (@l1) {
	$e2 = shift @l2;
	$e3 = shift @l3;
	if (!($k%2)) {
	    if ($e2 eq $e3) {
		print "$e2 ";
	    }
	    else {
		print "$e1 ";
	    }
	}
	else {
	    print "$e1 ";
	}
	$k++;
    }
    print "\n";
}

close C1;
close C2;
close C3;
